/*Copyright 2011, 2013 Alexandros Chortaras

 This file is part of Rapid.

 Rapid is free software: you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Rapid is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Rapid.  If not, see <http://www.gnu.org/licenses/>.*/

package edu.ntua.ivml.common.utils;

import java.util.ArrayList;

public class Utils {

    public static int binarySearch(ArrayList<Integer> a, int key) {
		int low = 0;
		int high = a.size() - 1;
		
		while (low <= high) {
			int mid = (low + high) >>> 1;
			int midVal = a.get(mid);
			
			if (midVal < key) {
				low = mid + 1;
			} else if (midVal > key) {
				high = mid - 1;
			} else {
				return mid;
			}
		}
		
		return -(low + 1);
    }
    
    public static <T> String printArray(T[] a) {
    	String res = "";
    	for (int i = 0; i < a.length; i++) {
    		res += a[i].toString();
    	}
    	return res;
    }

}
