/*Copyright 2011, 2013 Alexandros Chortaras

 This file is part of Rapid.

 Rapid is free software: you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Rapid is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Rapid.  If not, see <http://www.gnu.org/licenses/>.*/
package edu.ntua.ivml.qa.algorithm.rapid.elhi;

import java.util.ArrayList;
import java.util.Map;

import edu.ntua.ivml.common.lp.Atom;
import edu.ntua.ivml.common.lp.Clause;
import edu.ntua.ivml.qa.algorithm.rapid.AtomUnfolder;
import edu.ntua.ivml.qa.algorithm.rapid.AtomUnfolding;
import edu.ntua.ivml.qa.algorithm.rapid.ClauseUnfolder;
import edu.ntua.ivml.qa.algorithm.rapid.FlattenerExtra;
import edu.ntua.ivml.qa.algorithm.rapid.MarkedClause;
import edu.ntua.ivml.qa.algorithm.rapid.Rapid;
import edu.ntua.ivml.qa.algorithm.rapid.dllite.DLAtomUnfolding;
import edu.ntua.ivml.qa.lp.theory.FCTheory;


public class ETDatalogFlattener extends ETFlattener {
	
	public ETDatalogFlattener(FCTheory fc) {
		super(fc);
	}
	
	public AtomUnfolding createAtomUnfolding(VUnfoldStructure vus, Map<Atom, VUnfoldStructure> map, Atom head, FlattenerExtra extra) {
		for (Map.Entry<Atom, VUnfoldStructure> entry : map.entrySet()) {
			Atom b = Rapid.normalizeAtom(entry.getKey(), Rapid.dummyTerms).substAtom;
			for (HUnfoldStructure hus : entry.getValue().getElements()) {
				extra.add(new Clause(b, hus.toConjunction()), true);
			}
		}
		
		return new DLAtomUnfolding(new Atom[0], vus.getFunctionMaps());
	}
	
	public ArrayList<MarkedClause> getExtraQueries(AtomUnfolder au, ClauseUnfolder cu, FlattenerExtra extra) {
		ArrayList<MarkedClause> res = new ArrayList<>();
		
		int id = 0;
		for (int i = 0; i < extra.size(); i++) {
			if (!extra.getStateAt(i)) {
				continue;
			}

			res.add(new MarkedClause(extra.getClauseAt(i), id++));
		}
			
		return res;
	}

}
